/*
 * $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 *
 */

/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ident	"$Header: files.c 1.2 89/10/10 $@(#)nlp:lib/access/files.c	1.3"
/* EMACS_MODES: !fill, lnumb, !overwrite, !nodelete, !picture */

#include "errno.h"
#include "stdio.h"
#include "string.h"
#include "unistd.h"

#include "lp.h"

extern char		*malloc();

extern void		free();

/**
 ** getaccessfile() - BUILD NAME OF ALLOW OR DENY FILE
 **/

char			*getaccessfile (dir, name, prefix, base)
	char			*dir,
				*name,
				*prefix,
				*base;
{
	register char		*spooldir,
				*parent,
				*file,
				*f;

	if (!(spooldir = getspooldir()))
		return (0);

	/*
	 * It makes no sense talking about the access files if
	 * the directory for the form or printer doesn't exist.
	 */
	parent = makepath(spooldir, ADMINSDIR, LPUSER, dir, name, (char *)0);
	if (!parent)
		return (0);
	if (Access(parent, F_OK) == -1)
		return (0);

	if (!(f = malloc(strlen(prefix) + strlen(base) + 1))) {
		errno = ENOMEM;
		return (0);
	}
	strcpy (f, prefix);
	strcat (f, base);

	file = makepath(parent, f, (char *)0);
	free (f);
	free (parent);

	return (file);
}
